#ifndef __STRING_SUPPORT__
#include "StringSupport.h"
#endif



short Pos(const Str255 pat, const Str255 str)
// returns the offset to the first substring 'pat' in 'str'
// 0 if none
{
	short i=1;
	
	if (pat[0]==0) return 0;
	
	while(i <= str[0])
	{
		if (str[i] == pat[1])
		{
			short j=i+1;
			short k=2;
			if (k>pat[0]) return i;
			while (j <= str[0])
			{
				if (pat[k++] != str[j++]) break;
				if (k>pat[0]) return i;
			}
		}//if
		i += 1;
	}//while
	
	return 0;
} // Pos

static void AddToBuffer(const Str255 part, Str255 buffer)
{	short len;

	if (part)
	{
		len = part[0];
		if (buffer[0] + len >255)
			len = 255 - buffer[0];
		memmove(&buffer[1]+buffer[0],part+1,len);
		buffer[0] += len;
	}// if part
}

void Concat2(Str255 dest, const Str255 part1, const Str255 part2)
{
	dest[0] = 0;
	AddToBuffer(part1, dest);
	AddToBuffer(part2, dest);
} // Concat2

void Concat3(Str255 dest, const Str255 part1, const Str255 part2, const Str255 part3)
{
	dest[0] = 0;
	AddToBuffer(part1, dest);
	AddToBuffer(part2, dest);
	AddToBuffer(part3, dest);
} // Concat3

void Concat4(Str255 dest, const Str255 part1, const Str255 part2, const Str255 part3, const Str255 part4)
{
	dest[0] = 0;
	AddToBuffer(part1, dest);
	AddToBuffer(part2, dest);
	AddToBuffer(part3, dest);
	AddToBuffer(part4, dest);
} // Concat4


void Delete(Str255 dest, short idx, short len)
{
	if (idx < 1)
		{ len -= 1-idx; idx = 1; }	// see definition of delte in think Pascal manual
	if (idx+len-1 > dest[0])
		{ len = dest[0] - idx + 1; }
	if (len > 0)
	{	memmove(dest+idx,dest+idx+len,dest[0]-(len+idx-1));
		dest[0] -= len;
	}
} // Delete


void SetStr255(Str255 dest, const Str255 source)
{
	if (dest) memmove(dest,source,source[0]+1);
}

void Copy(Str255 dest, const Str255 source, int index, int count)
// Sets dest to a string containging count characters
// from source, beginning at source[index]. If count  0 the a null string is
// returned. If index<1 or index+count>length(source) it is not an error, see
// think pascal manual page 361
{
	if (index<1)
	{	count -= 1-index;
		index = 1;
	}
	if (count+index > source[0])
		count = source[0]-index+1;
	dest[0] = 0;
	if (count>0)
	{	memmove(dest+1,source+index,count);
		dest[0] = count;
	}
} // Copy

Boolean EqualStr255(const Str255 s1, const Str255 s2)
	// returns true if s1=s2
{	short i;

	if (s1[0] != s2[0]) return false;
	for (i=1; i <= s1[0]; i++)
		if (s1[i] != s2[i]) return false;
	return true;
} // EqualStr255

void AppendStr255(Str255 dest, const Str255 tail)
	// appends tail to dest
{
	long ll;
	short len;
	
	len = dest[0];
	if (len + tail[0] > 255)
		ll = 255 - len;
	else
		ll = tail[0];
	memmove(dest + len+1, tail+1, ll);
	dest[0] += ll;
} // AppendStr255

#pragma mark -
