#ifndef __STRING_SUPPORT__
#define __STRING_SUPPORT__

#ifdef __cplusplus
extern "C" {
#endif

// routines for handling pascal strings:

short Pos(const Str255 pat, const Str255 str);
	// returns the offset to the first substring 'pat' in 'str'
	// 0 if no such pattern

void Concat2(Str255 dest, const Str255 part1, const Str255 part2);
	// concatenates part1, part2 into dest
	// dest can also be equal to any of the partsN

void Concat3(Str255 dest, const Str255 part1, const Str255 part2, const Str255 part3);
	// concatenates part1, part2, part3 into dest
	// dest can also be equal to any of the partsN

void Concat4(Str255 dest, const Str255 part1, const Str255 part2, const Str255 part3, const Str255 part4);
	// concatenates part1, part2, part3, part4 into dest
	// dest can also be equal to any of the partsN

void Delete(Str255 dest, short idx, short len);
	// deletes len chars from idx (idx=1: from start)

void SetStr255(Str255 dest, const Str255 source);
	// corresponds to dest := source 

void Copy(Str255 dest, const Str255 source, int index, int count);
	// Sets dest to a string containging count characters
	// from source, beginning at source[index]. If count  0 the a null string is
	// returned. If index<1 or index+count>length(source) it is not an error, see
	// think pascal manual page 361

void AppendStr255(Str255 dest, const Str255 tail);
	// appends tail to dest

Boolean EqualStr255(const Str255 s1, const Str255 s2);
	// returns true if s1=s2

#ifdef __cplusplus
}
#endif

#endif
